package org.osgeo.mapguide;


/**
 * Substitution tags used within the XML file for a resource.
 *
 */
public class MgResourceTag
{
   
/**
 * Replaced with the name of the currently logged in user.
 *
 */

   public static final String LoginUsername  = "%MG_LOGIN_USERNAME%"; /// \if INTERNAL  \endif 
   
/**
 * Replaced with the password of the currently logged in user.
 *
 */

   public static final String LoginPassword  = "%MG_LOGIN_PASSWORD%"; /// \if INTERNAL  \endif 
   
/**
 * Replaced with the default resource-specific username.
 *
 */

   public static final String Username  = "%MG_USERNAME%"; /// \if INTERNAL  \endif 
   
/**
 * Replaced with the default resource-specific password.
 *
 */

   public static final String Password  = "%MG_PASSWORD%"; /// \if INTERNAL  \endif 
   
/**
 * Replaced with the location of data files associated with the
 * given resource. The trailing "/" is included.
 *
 */

   public static final String DataFilePath  = "%MG_DATA_FILE_PATH%"; /// \if INTERNAL  \endif 
   
/**
 * Replaced with the location of tile cache associated with the
 * given resource. The trailing "/" is included.
 *
 */

   public static final String TileCachePath  = "%MG_TILE_CACHE_PATH%"; /// \if INTERNAL  \endif 
   
/**
 * Denotes beginning of data path alias.
 *
 */

   public static final String DataPathAliasBegin  = "%MG_DATA_PATH_ALIAS["; /// \if INTERNAL  \endif 
   
/**
 * Denotes end of data path alias.
 *
 */

   public static final String DataPathAliasEnd  = "]%"; /// \if INTERNAL  \endif 
   
}

