/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * Performs map related operations such as getting an eMap DWF
 * representing a map or updates to a map, or querying features
 * from maps or layers of a map.
 *
 */
 public class MgdMappingService extends MgService {
  private long swigCPtr;

  public MgdMappingService(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgdMappingServiceToMgService(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgdMappingService() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgdMappingService(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgdMappingService obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * GenerateLegendImage() returns the legend image for the specified layer.
 *
 * @param  resource ({@link MgResourceIdentifier})  Input  {@link MgResourceIdentifier} object identifying the layer definition resource.
 * @param  scale (double)  Input  The scale at which the symbolization is requested.
 * @param  width (int)  Input  The requested image width in pixels.
 * @param  height (int)  Input  The requested image height in pixels.
 * @param  format (String/string)  Input  Image format, from {@link MgImageFormats}. Example: PNG, JPG, PNG8, etc
 * @param  geomType (int)  Input  The type of symbolization required: 1=Point, 2=Line, 3=Area, 4=Composite
 * @param  themeCategory (int)  Input  The value indicating which theme category swatch to return.  Used when there is a theme defined at this scale. An exception will be  thrown if a requested them category doesn't exist.
 * @return  Returns a stream representing the legend image.
 *  The default returned image format will be PNG8 unless a different supported
 *  format is requested. An exception will be thrown if an unsupported image
 *  format is requested.
 * @exception  MgArgumentOutOfRangeException
 * @exception  MgInvalidResourceTypeException
 * @exception  MgNullArgumentException
 * @exception  MgInvalidImageFormatException
 */
 public MgByteReader generateLegendImage(MgResourceIdentifier resource, double scale, int width, int height, String format, int geomType, int themeCategory) {
    long cPtr = MapGuideDesktopApiJNI.MgdMappingService_GenerateLegendImage(swigCPtr, MgResourceIdentifier.getCPtr(resource), scale, width, height, format, geomType, themeCategory);
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Plot The map to an EPlot DWF using the center and scale from the map.  The
 * extents will be computed to fill the space within the page margins.  If the
 * layout paramter is null, no adornments will be added to the page.
 *
 * @param  map ({@link MgdMap})  Map object describing current state of map.
 * @param  plotSpec ({@link MgdPlotSpecification})  Plotting specifications for the generated plot.
 * @param  layout ({@link MgdLayout})  Layout specifications to use for the generated plot.
 * @param  dwfVersion ({@link MgdDwfVersion})  DWF version required by the client. This  determines the schema and file versions used to  generate the DWFs sent back to the client.
 * @return  Returns an {@link MgByteReader} object containing a DWF in ePlot format.
 * @exception  MgNullArgumentException
 */
 public MgByteReader generatePlot(MgdMap map, MgdPlotSpecification plotSpec, MgdLayout layout, MgdDwfVersion dwfVersion) {
    long cPtr = MapGuideDesktopApiJNI.MgdMappingService_GeneratePlot__SWIG_0(swigCPtr, MgdMap.getCPtr(map), MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout), MgdDwfVersion.getCPtr(dwfVersion));
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Plot the map to an EPlot DWF using the specified center and scale.  The extents
 * will be computed to fill the space within the page margins.  If the layout
 * paramter is null, no adornments will be added to the page.
 *
 * @param  map ({@link MgdMap})  Map object describing current state of map.
 * @param  center ({@link MgCoordinate})  The coordinates of the center of the map for the plot.
 * @param  scale (double)  The scale to use for the plot.
 * @param  plotSpec ({@link MgdPlotSpecification})  Plotting specifications for the generated plot.
 * @param  layout ({@link MgdLayout})  Layout specifications to use for the generated plot.
 * @param  dwfVersion ({@link MgdDwfVersion})  DWF version required by the client. This  determines the schema and file versions used to  generate the DWFs sent back to the client.
 * @return  Returns an {@link MgByteReader} object containing a DWF in ePlot format.
 * @exception  MgNullArgumentException
 */
 public MgByteReader generatePlot(MgdMap map, MgCoordinate center, double scale, MgdPlotSpecification plotSpec, MgdLayout layout, MgdDwfVersion dwfVersion) {
    long cPtr = MapGuideDesktopApiJNI.MgdMappingService_GeneratePlot__SWIG_1(swigCPtr, MgdMap.getCPtr(map), MgCoordinate.getCPtr(center), scale, MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout), MgdDwfVersion.getCPtr(dwfVersion));
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Plot the map to an EPlot DWF using the extent specified in the mapping
 * coordinate space.  The center and scale will be computed based on the extent
 * specified.  If expandToFit is true, then the extent specified will be expanded
 * in the X or Y direction to fill the space within the page margins.  If the
 * layout paramter is null, no adornments will be added to the page.
 *
 * @param  map ({@link MgdMap})  Map object describing current state of map.
 * @param  extents ({@link MgEnvelope})  The extents of the map to be plotted..
 * @param  expandToFit (boolean/bool)  Flag indicating whether the extents should be expanded to  fill the space withing the page margins.
 * @param  plotSpec ({@link MgdPlotSpecification})  Plotting specifications for the generated plot.
 * @param  layout ({@link MgdLayout})  Layout specifications to use for the generated plot.
 * @param  dwfVersion ({@link MgdDwfVersion})  DWF version required by the client. This  determines the schema and file versions used to  generate the DWFs sent back to the client.
 * @return  Returns an {@link MgByteReader} object containing a DWF in ePlot format.
 * @exception  MgNullArgumentException
 */
 public MgByteReader generatePlot(MgdMap map, MgEnvelope extents, boolean expandToFit, MgdPlotSpecification plotSpec, MgdLayout layout, MgdDwfVersion dwfVersion) {
    long cPtr = MapGuideDesktopApiJNI.MgdMappingService_GeneratePlot__SWIG_2(swigCPtr, MgdMap.getCPtr(map), MgEnvelope.getCPtr(extents), expandToFit, MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout), MgdDwfVersion.getCPtr(dwfVersion));
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * TODO: API Documentation is missing or failed to translate doxygen brief directive (message inserted by IMake.exe)
 * @param  mapPlots ({@link MgdMapPlotCollection})  A collection of MapPlot objects.
 * @param  dwfVersion ({@link MgdDwfVersion})  DWF specification required by the client. This  determines the schema and file versions used to  generate the DWFs sent back to the client.
 * @return  Returns an {@link MgByteReader} object containing a DWF
 *  in ePlot format with multiple sheets, one for each
 *  map.
 * @exception  MgNullArgumentException
 */
 public MgByteReader generateMultiPlot(MgdMapPlotCollection mapPlots, MgdDwfVersion dwfVersion) {
    long cPtr = MapGuideDesktopApiJNI.MgdMappingService_GenerateMultiPlot(swigCPtr, MgdMapPlotCollection.getCPtr(mapPlots), MgdDwfVersion.getCPtr(dwfVersion));
    return (cPtr == 0) ? null : (MgByteReader)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

}
